Index: trunk/BNC/src/bncwindow.cpp
===================================================================
--- trunk/BNC/src/bncwindow.cpp	(revision 9760)
+++ trunk/BNC/src/bncwindow.cpp	(revision 9783)
@@ -992,6 +992,6 @@
   pppLayout1->addWidget(new QLabel("Data source"),           ir, 0);
   pppLayout1->addWidget(_pppWidgets._dataSource,             ir, 1);
-  pppLayout1->addWidget(new QLabel("   Version 2 filenames"),ir, 4);
-  pppLayout1->addWidget(_pppWidgets._v2filenames,            ir, 5, 1, 3);
+  pppLayout1->addWidget(new QLabel("   Logfile directory"),  ir, 4);
+  pppLayout1->addWidget(_pppWidgets._logPath,                ir, 5, 1, 3);
   ++ir;
   pppLayout1->addWidget(new QLabel("Corrections stream"),    ir, 0);
@@ -999,6 +999,15 @@
   pppLayout1->addWidget(new QLabel("Corrections file"),      ir, 2);
   pppLayout1->addWidget(_pppWidgets._corrFile,               ir, 3);
-  pppLayout1->addWidget(new QLabel("   Logfile directory"),  ir, 4);
-  pppLayout1->addWidget(_pppWidgets._logPath,                ir, 5, 1, 3);
+  pppLayout1->addWidget(new QLabel("   NMEA directory"),     ir, 4);
+  pppLayout1->addWidget(_pppWidgets._nmeaPath,               ir, 5, 1, 3);
+  ++ir;
+#ifdef USE_PPP
+  pppLayout1->addWidget(new QLabel("Ionosphere stream"),     ir, 0);
+  pppLayout1->addWidget(_pppWidgets._ionoMount,              ir, 1);
+  pppLayout1->addWidget(new QLabel("Ionosphere file"),       ir, 2);
+  pppLayout1->addWidget(_pppWidgets._ionoFile,               ir, 3);
+#endif
+  pppLayout1->addWidget(new QLabel("   SNX TRO directory"),  ir, 4);
+  pppLayout1->addWidget(_pppWidgets._snxtroPath,             ir, 5, 1, 3);
   ++ir;
   pppLayout1->addWidget(new QLabel("RINEX Obs file"),        ir, 0);
@@ -1006,13 +1015,17 @@
   pppLayout1->addWidget(new QLabel("RINEX Nav file"),        ir, 2);
   pppLayout1->addWidget(_pppWidgets._rinexNav,               ir, 3);
-  pppLayout1->addWidget(new QLabel("   NMEA directory"),     ir, 4);
-  pppLayout1->addWidget(_pppWidgets._nmeaPath,               ir, 5, 1, 3);
+  pppLayout1->addWidget(new QLabel("   SNX TRO interval"),   ir, 4);
+  pppLayout1->addWidget(_pppWidgets._snxtroIntr,             ir, 5);
+  pppLayout1->addWidget(new QLabel("   SNX TRO sampling"),   ir, 6);
+  pppLayout1->addWidget(_pppWidgets._snxtroSampl,            ir, 7, Qt::AlignRight);
   ++ir;
-  pppLayout1->addWidget(new QLabel("Coordinates file"),      ir, 0);
-  pppLayout1->addWidget(_pppWidgets._crdFile,                ir, 1);
-  pppLayout1->addWidget(new QLabel("ANTEX file"),            ir, 2);
-  pppLayout1->addWidget(_pppWidgets._antexFile,              ir, 3);
-  pppLayout1->addWidget(new QLabel("   SNX TRO directory"),  ir, 4);
-  pppLayout1->addWidget(_pppWidgets._snxtroPath,             ir, 5, 1, 3);
+  pppLayout1->addWidget(new QLabel("ANTEX file"),            ir, 0);
+  pppLayout1->addWidget(_pppWidgets._antexFile,              ir, 1);
+  pppLayout1->addWidget(new QLabel("Coordinates file"),      ir, 2);
+  pppLayout1->addWidget(_pppWidgets._crdFile,                ir, 3);
+  pppLayout1->addWidget(new QLabel("   SNX TRO AC"),         ir, 4);
+  pppLayout1->addWidget(_pppWidgets._snxtroAc,               ir, 5);
+  pppLayout1->addWidget(new QLabel("   SNX TRO solution"),   ir, 6);
+  pppLayout1->addWidget(_pppWidgets._snxtroSol,              ir, 7, Qt::AlignRight);
   ++ir;
 #ifdef USE_PPP
@@ -1020,17 +1033,4 @@
   pppLayout1->addWidget(_pppWidgets._blqFile,                ir, 1);
 #endif
-  pppLayout1->addWidget(new QLabel("   SNX TRO interval"),   ir, 4);
-  pppLayout1->addWidget(_pppWidgets._snxtroIntr,             ir, 5);
-  pppLayout1->addWidget(new QLabel("   SNX TRO sampling"),   ir, 6);
-  pppLayout1->addWidget(_pppWidgets._snxtroSampl,            ir, 7, Qt::AlignRight);
-  ++ir;
-  pppLayout1->addWidget(new QLabel("Ionosphere stream"),     ir, 0);
-  pppLayout1->addWidget(_pppWidgets._ionoMount,              ir, 1);
-  pppLayout1->addWidget(new QLabel("Ionosphere file"),       ir, 2);
-  pppLayout1->addWidget(_pppWidgets._ionoFile,               ir, 3);
-  pppLayout1->addWidget(new QLabel("   SNX TRO AC"),         ir, 4);
-  pppLayout1->addWidget(_pppWidgets._snxtroAc,               ir, 5);
-  pppLayout1->addWidget(new QLabel("   SNX TRO solution"),   ir, 6);
-  pppLayout1->addWidget(_pppWidgets._snxtroSol,              ir, 7, Qt::AlignRight);
   pppLayout1->setRowStretch(ir+1, 999);
   pppGroup1->setLayout(pppLayout1);
@@ -1080,5 +1080,5 @@
   pppLayout3->addWidget(_pppWidgets._minObs,                ir, 4);
   pppLayout3->addWidget(new QLabel("Min Elevation"),        ir, 6, Qt::AlignLeft);
-  pppLayout3->addWidget(_pppWidgets._minEle,                ir, 7);
+  pppLayout3->addWidget(_pppWidgets._minEle,                ir, 7);_pppWidgets._minEle->setMaximumWidth(8*ww);
   ++ir;
   pppLayout3->addWidget(new QLabel("Model Obs"),            ir, 0, Qt::AlignLeft);
@@ -1087,5 +1087,5 @@
   pppLayout3->addWidget(_pppWidgets._corrWaitTime,          ir, 4);
   pppLayout3->addWidget(new QLabel("Seeding (sec)"),        ir, 6, Qt::AlignLeft);
-  pppLayout3->addWidget(_pppWidgets._seedingTime,           ir, 7);
+  pppLayout3->addWidget(_pppWidgets._seedingTime,           ir, 7);_pppWidgets._seedingTime->setMaximumWidth(8*ww);
   ++ir;
   pppLayout3->addWidget(new QLabel("Pseudo Obs"),           ir, 0, Qt::AlignLeft);
@@ -1464,20 +1464,21 @@
   // WhatsThis, PPP (1)
   // ------------------
-  _pppWidgets._dataSource->setWhatsThis(tr("<p>Select 'Real-time Streams' for real-time PPP from RTCM streams or 'RINEX Files' for post processing PPP from RINEX files.</p><p><ul><li>Real-time PPP requires that you pull a RTCM stream carrying GNSS observations plus a stream providing corrections to Broadcast Ephemeris. If the observations stream does not contain Broadcast Ephemeris then you must in addition pull a Broadcast Ephemeris stream like 'RTCM3EPH' from Ntrip Broadcaster <u>products.igs-ip.net</u>.<br></li><li>Post processing PPP requires RINEX Observation files, RINEX Navigation files and a file with corrections to Broadcast Ephemeris in plain ASCII format as saved beforehand using BNC.</li></ul></p><p>Note that BNC allows to carry out PPP solutions simultaneously for several stations.</p>"));
-  _pppWidgets._rinexObs->setWhatsThis(tr("<p>Specify the RINEX Observation file.</p>"));
-  _pppWidgets._rinexNav->setWhatsThis(tr("<p>Specify the RINEX Navigation file.</p>"));
-  _pppWidgets._corrMount->setWhatsThis(tr("<p>Specify a 'mountpoint' from the 'Streams' canvas below which provides corrections to Broadcast Ephemeris.</p><p>If you don't specify a corrections stream via this option, BNC will fall back to Single Point Positioning (SPP, positioning from observations and Broadcast Ephemeris only) instead of doing PPP.</p>"));
-  _pppWidgets._corrFile->setWhatsThis(tr("<p>Specify the Broadcast Ephemeris Corrections file as saved beforehand using BNC.</p><p>If you don't specify corrections by this option, BNC will fall back to Single Point Positioning (SPP, positioning from RINEX Obs and RINEX Nav files only) instead of doing PPP.</p>"));
-  _pppWidgets._antexFile->setWhatsThis(tr("<p>Observations in RTCM streams or RINEX files should be referred to the receiver's and to the satellite's Antenna Phase Center (APC) and therefore be corrected for<ul><li>Receiver APC offsets</li><li>Receiver APC variations</li><li>Satellite APC offsets.</li></ul> Specify the full path to an IGS 'ANTEX file' which contains APC offsets and variations.</p><p>If you don't specify an 'ANTEX file' then observations will not be corrected for APC offsets and variations.</p>"));
-  _pppWidgets._crdFile->setWhatsThis(tr("<p>Enter the full path to an ASCII file which specifies the streams or files of those stations you want to process. Specifying a 'Coordinates file' is optional. If it exists, it should contain one record per station with the following parameters separated by blank character:<p><ul><li>Specify the station either by<ul><li>the 'Mountpoint' of the station's RTCM stream (when in real-time PPP mode), or</li><li>the 4-charater station ID of the RINEX Observations file (when in post processing PPP mode).</li></ul></li><li>Approximate X,Y,Z coordinate of station's Antenna Reference Point [m] (ARP, specify '0.0 0.0 0.0' if unknown).</li><li>North, East and Up component of antenna eccentricity [m] (specify '0.0 0.0 0.0' if unknown).</li><li>20 Characters describing the antenna type and radome following the IGS 'ANTEX file' standard (leave blank if unknown).</li><li>Receiver type following the naming conventions for IGS equipment.</li></ul></p><p>Records with exclamation mark '!' in the first column or blank records will be interpreted as comment lines and ignored.</p>"));
-  _pppWidgets._v2filenames->setWhatsThis(tr("<p>Tick 'Version 2 filenames' to let BNC create filenames for PPP logfiles , NMEA files and SINEX Troposphere files following the RINEX Version 2 standard.</p><p>Default is an empty check box, meaning to create filenames following the RINEX Version 3 standard. The file content is not affected by this option. It only concerns the filenames.</p>"));
-  _pppWidgets._logPath->setWhatsThis(tr("<p>Specify a directory for saving daily PPP logfiles. If the specified directory does not exist, BNC will not create such files.</p><p>Default is an empty option field, meaning that no PPP logfiles shall be produced.</p>"));
-  _pppWidgets._nmeaPath->setWhatsThis(tr("<p>Specify a directory for saving coordinates in daily NMEA files. If the specified directory does not exist, BNC will not create such files.</p><p>Default is an empty option field, meaning that no NMEA file shall be produced.</p>"));
-  _pppWidgets._snxtroPath->setWhatsThis(tr("<p>Specify a directory for saving SINEX Troposphere files. If the specified directory does not exist, BNC will not create such files.</p><p>Default is an empty option field, meaning that no SINEX Troposphere files shall be produced.</p>"));
-  _pppWidgets._snxtroIntr->setWhatsThis(tr("<p>Select a length for SINEX Troposphere files.</p><p>Default 'SNX TRO interval' for saving SINEX Troposphere files on disk is '1 hour'.</p>"));
-  _pppWidgets._snxtroSampl->setWhatsThis(tr("<p>Select a 'Sampling' rate for saving troposphere parameters.</p>"));
-  _pppWidgets._snxtroAc->setWhatsThis(tr("<p>Specify a 3-character abbreviation describing you as the generating Analysis Center (AC) in your SINEX troposphere files.</p>"));
-  _pppWidgets._snxtroSol->setWhatsThis(tr("<p>Specify a 4-character solution ID to allow a distingtion between different solutions per AC.</p>"));
-  _pppWidgets._ionoMount->setWhatsThis(tr("<p>Specify a 'mountpoint' from the 'Streams' canvas below which provides VTEC informations in SSR format.</p><p>If you don't specify a corrections stream via this option, BNC will use VTEC informations from the Corrections stream 'mountpoint', if available.</p>"));
+  _pppWidgets._dataSource->setWhatsThis(tr("<p>Select 'Real-time Streams' for real-time PPP from RTCM streams or 'RINEX Files' for post processing PPP from RINEX files.</p><p><ul><li>Real-time PPP requires that you pull a RTCM stream carrying GNSS observations plus a stream providing corrections to Broadcast Ephemeris. If the observations stream does not contain Broadcast Ephemeris then you must in addition pull a Broadcast Ephemeris stream like 'RTCM3EPH' from Ntrip Broadcaster <u>products.igs-ip.net</u>.<br></li><li>Post processing PPP requires RINEX Observation files, RINEX Navigation files and a file with corrections to Broadcast Ephemeris in plain ASCII format as saved beforehand using BNC.</li></ul></p><p>Note that BNC allows to carry out PPP solutions simultaneously for several stations. <i>[key: PPP/]</i></p>"));
+  _pppWidgets._rinexObs->setWhatsThis(tr("<p>Specify the RINEX Observation file. <i>[key: PPP/rinexObs]</i></p>"));
+  _pppWidgets._rinexNav->setWhatsThis(tr("<p>Specify the RINEX Navigation file. <i>[key: PPP/rinexNav]</i></p>"));
+  _pppWidgets._corrMount->setWhatsThis(tr("<p>Specify a 'mountpoint' from the 'Streams' canvas below which provides corrections to Broadcast Ephemeris.</p><p>If you don't specify a corrections stream via this option, BNC will fall back to Single Point Positioning (SPP, positioning from observations and Broadcast Ephemeris only) instead of doing PPP. <i>[key: PPP/corrMount]</i></p>"));
+  _pppWidgets._ionoMount->setWhatsThis(tr("<p>Specify a 'mountpoint' from the 'Streams' canvas below which provides VTEC informations in SSR format.</p><p>If you don't specify a corrections stream via this option, BNC will use VTEC informations from the Corrections stream 'mountpoint', if available. <i>[key: PPP/ionoMount]</i></p>"));
+  _pppWidgets._corrFile->setWhatsThis(tr("<p>Specify the Broadcast Ephemeris Corrections file as saved beforehand using BNC.</p><p>If you don't specify corrections by this option, BNC will fall back to Single Point Positioning (SPP, positioning from RINEX Obs and RINEX Nav files only) instead of doing PPP. <i>[key: PPP/corrFile]</i></p>"));
+  _pppWidgets._ionoFile->setWhatsThis(tr("<p>Specify the VTEC file as saved beforehand using BNC.</p><p>If you don't specify corrections by this option, BNC will use VTEC informations from the Corrections file, if available. <i>[key: PPP/ionoFile]</i></p>"));
+  _pppWidgets._antexFile->setWhatsThis(tr("<p>Observations in RTCM streams or RINEX files should be referred to the receiver's and to the satellite's Antenna Phase Center (APC) and therefore be corrected for<ul><li>Receiver APC offsets</li><li>Receiver APC variations</li><li>Satellite APC offsets.</li></ul> Specify the full path to an IGS 'ANTEX file' which contains APC offsets and variations.</p><p>If you don't specify an 'ANTEX file' then observations will not be corrected for APC offsets and variations. <i>[key: PPP/antexFile]</i></p>"));
+  _pppWidgets._crdFile->setWhatsThis(tr("<p>Enter the full path to an ASCII file which specifies the streams or files of those stations you want to process. Specifying a 'Coordinates file' is optional. If it exists, it should contain one record per station with the following parameters separated by blank character:<p><ul><li>Specify the station either by<ul><li>the 'Mountpoint' of the station's RTCM stream (when in real-time PPP mode), or</li><li>the 4-charater station ID of the RINEX Observations file (when in post processing PPP mode).</li></ul></li><li>Approximate X,Y,Z coordinate of station's Antenna Reference Point [m] (ARP, specify '0.0 0.0 0.0' if unknown).</li><li>North, East and Up component of antenna eccentricity [m] (specify '0.0 0.0 0.0' if unknown).</li><li>20 Characters describing the antenna type and radome following the IGS 'ANTEX file' standard (leave blank if unknown).</li><li>Receiver type following the naming conventions for IGS equipment.</li></ul></p><p>Records with exclamation mark '!' in the first column or blank records will be interpreted as comment lines and ignored. <i>[key: PPP/crdFile]</i></p>"));
+  _pppWidgets._logPath->setWhatsThis(tr("<p>Specify a directory for saving daily PPP logfiles. If the specified directory does not exist, BNC will not create such files.</p><p>Default is an empty option field, meaning that no PPP logficorrMountles shall be produced. <i>[key: PPP/logPath]</i></p>"));
+  _pppWidgets._nmeaPath->setWhatsThis(tr("<p>Specify a directory for saving coordinates in daily NMEA files. If the specified directory does not exist, BNC will not create such files.</p><p>Default is an empty option field, meaning that no NMEA file shall be produced. <i>[key: PPP/nmeaPath]</i></p>"));
+  _pppWidgets._snxtroPath->setWhatsThis(tr("<p>Specify a directory for saving SINEX Troposphere files. If the specified directory does not exist, BNC will not create such files.</p><p>Default is an empty option field, meaning that no SINEX Troposphere files shall be produced. <i>[key: PPP/snxtroPath]</i></p>"));
+  _pppWidgets._snxtroIntr->setWhatsThis(tr("<p>Select a length for SINEX Troposphere files.</p><p>Default 'SNX TRO interval' for saving SINEX Troposphere files on disk is '1 hour'. <i>[key: PPP/snxtroIntr]</i></p>"));
+  _pppWidgets._snxtroSampl->setWhatsThis(tr("<p>Select a 'Sampling' rate for saving troposphere parameters. <i>[key: PPP/snxtroSampl]</i></p>"));
+  _pppWidgets._snxtroAc->setWhatsThis(tr("<p>Specify a 3-character abbreviation describing you as the generating Analysis Center (AC) in your SINEX troposphere files. <i>[key: PPP/snxtroAc]</i></p>"));
+  _pppWidgets._snxtroSol->setWhatsThis(tr("<p>Specify a 4-character solution ID to allow a distinction between different solutions per AC. <i>[key: PPP/snxtroSol]</i></p>"));
+
 
   // WhatsThis, PPP (3)