Index: trunk/BNC/Example_Configs/17_Combi.bnc
===================================================================
--- trunk/BNC/Example_Configs/17_Combi.bnc	(revision 9538)
+++ trunk/BNC/Example_Configs/17_Combi.bnc	(revision 9814)
@@ -5,17 +5,17 @@
 adviseScript=
 autoStart=0
-casterUrlList=http://Example:Configs@products.igs-ip.net:2101, http://User:Pass@igs-ip.net:2101, http://User:Pass@euref-ip.net:2101
+casterUrlList=http://Example:Configs@products.igs-ip.net:2101, http://Example:Configs@www.igs-ip.net:2101, http://Example:Configs@gref-ip.de:2101, http://user:pass@www.euref-ip.net:2101, http://user:pass@mgex.igs-ip.net:2101
 cmbBds=0
-cmbGal=0
+cmbBsxFile=
+cmbGal=2
 cmbGlo=0
 cmbGps=2
 cmbIrnss=0
-cmbMaxres=0.20
-cmbMethod=Filter
+cmbMaxres=0.1
+cmbMethod=Kalman Filter
 cmbQzss=0
 cmbSampl=10
 cmbSbas=0
-cmbStreams="SSRA01IGS0 ESA 1.0 ", "SSRA02IGS0 BKG 1.0 "
-cmbUseGlonass=0
+cmbStreams="SSRA00CNE1 CNE 1.0 ", "SSRA00BKG1 BKG 1.0 ", "SSRA00GFZ1 GFZ 1.0 "
 corrIntr=1 day
 corrPath=
@@ -25,5 +25,5 @@
 ephPath=
 ephV2=0
-ephV3=0
+ephVersion=4
 font=
 logFile=Output/Combi.log
@@ -32,5 +32,5 @@
 miscPort=
 miscScanRTCM=0
-mountPoints=//Example:Configs@products.igs-ip.net:2101/BCEP01BKG0 RTCM_3.1 DEU 50.09 8.66 no 2, //Example:Configs@products.igs-ip.net:2101/SSRA01IGS0 RTCM_3.1 DEU 49.87 8.62 no 2, //Example:Configs@products.igs-ip.net:2101/SSRA02IGS0 RTCM_3.1 DEU 50.09 8.66 no 2
+mountPoints=//Example:Configs@products.igs-ip.net:2101/BCEP00BKG0 RTCM_3.3 DEU 50.09 8.66 no 2, //Example:Configs@products.igs-ip.net:2101/SSRA00BKG1 RTCM_3.1 DEU 50.09 8.66 no 2, //Example:Configs@products.igs-ip.net:2101/SSRA00CNE1 RTCM_3.1 FRA 43.56 1.48 no 2, //Example:Configs@products.igs-ip.net:2101/SSRA00GFZ1 RTCM_3.1 DEU 52.38 13.07 no 2, //Example:Configs@www.igs-ip.net:2101/FFMJ00DEU0 RTCM_3.3 DEU 50.09 8.66 no 2
 ntripVersion=2
 onTheFlyInterval=no
@@ -46,5 +46,5 @@
 reqcAction=
 reqcComment=
-reqcEndDateTime=
+reqcEndDateTime=2099-01-01T00:00:00
 reqcLogSummaryOnly=0
 reqcNavFile=
@@ -72,10 +72,10 @@
 reqcRnxVersion=
 reqcRunBy=
-reqcSampling=
-reqcSkyPlotSignals=
-reqcStartDateTime=
+reqcSampling=1 sec
+reqcSkyPlotSignals=C:2&7 E:1&5 G:1&2&5 J:1&2 R:1&2&3 S:1&5 I:5&9
+reqcStartDateTime=1967-11-02T00:00:00
 reqcUseObsTypes=
-reqcV2Priority=
-rnxAppend=2
+reqcV2Priority=G:12&PWCSLX G:5&IQX R:12&PC R:3&IQX R:46&ABX E:16&BCXZ E:578&IQX J:1&SLXCZ J:26&SLX J:5&IQX C:267&IQX C:128&DPX C:7&DPZ I:ABCX S:1&C S:5&IQX
+rnxAppend=0
 rnxIntr=1 day
 rnxOnlyWithSKL=0
@@ -86,6 +86,6 @@
 rnxSkelPath=
 rnxV2=0
-rnxV2Priority=CWPX_?
-rnxV3=0
+rnxV2Priority=G:12&PWCSLX G:5&IQX R:12&PC R:3&IQX R:46&ABX E:16&BCXZ E:578&IQX J:1&SLXCZ J:26&SLX J:5&IQX C:267&IQX C:128&DPX C:7&DPZ I:ABCX S:1&C S:5&IQX
+rnxVersion=4
 serialAutoNMEA=Auto
 serialBaudRate=9600
@@ -94,5 +94,5 @@
 serialFlowControl=OFF
 serialHeightNMEA=
-serialManualNMEASampling=0
+serialManualNMEASampling=10
 serialMountPoint=
 serialParity=NONE
@@ -103,4 +103,5 @@
 sp3CompOutLogFile=
 sslCaCertPath=
+sslClientCertPath=
 sslIgnoreErrors=0
 startTab=16
@@ -122,16 +123,12 @@
 trafo_t0=
 uploadAntexFile=Input/igs14.atx
-uploadEphHost=
-uploadEphMountpoint=
 uploadEphMountpointsOut=
-uploadEphPassword=
-uploadEphPort=
-uploadEphSample=5
 uploadIntr=1 day
-uploadMountpointsOut="products.igs-ip.net,2101,CLOCK,1,,,IGS14,RTCM-SSR,2,Output/BNCOUTPUT${V3PROD}.sp3,Output/BNCOUTPUT${V3PROD}.clk,,,,0 byte(s),"
-uploadSamplClkRnx=0
-uploadSamplRtcmEph=0
-uploadSamplRtcmEphCorr=0
-uploadSamplSp3=0
+uploadMountpointsOut="products.igs-ip.net,2101,SSRA02IGS1_T,2,,,IGS14,IGS-SSR,2,Output/BNC0SSRRTS${V3PROD}.sp3,Output/BNC0SSRRTS${V3PROD}.clk,,,,,0 byte(s),"
+uploadSamplBiaSnx=60
+uploadSamplClkRnx=5
+uploadSamplRtcmEph=5
+uploadSamplRtcmEphCorr=5
+uploadSamplSp3=1
 
 [PPP]
@@ -141,20 +138,23 @@
 corrFile=
 corrMount=
-corrWaitTime=0
+corrWaitTime=5
 crdFile=
 dataSource=
-eleWgtCode=0
-eleWgtPhase=0
+eleWgtCode=2
+eleWgtPhase=2
+ionoFile=
+ionoMount=
 lcBDS=no
 lcGLONASS=no
-lcGPS=no
-lcGalileo=no
+lcGPS=Pi&Li
+lcGalileo=Pi&Li
 logPath=
-mapSpeedSlider=100
+mapSpeedSlider=48
 mapWinDotColor=red
 mapWinDotSize=
-maxResC1=4.0
+maxResC1=3.0
+maxResGIM=3.0
 maxResL1=0.03
-minEle=0
+minEle=7
 minObs=5
 modelObs=Ionosphere-free PPP
@@ -164,8 +164,9 @@
 rinexNav=
 rinexObs=
-seedingTime=0
-sigmaC1=2.0
+seedingTime=10
+sigmaC1=10.0
 sigmaGIM=4.0
 sigmaL1=0.01
+sigmaTz0=0.10
 snxtroAc=
 snxtroIntr=1 hour
@@ -173,5 +174,4 @@
 snxtroSampl=1 sec
 snxtroSol=
-staTable=",,,,,,,,,,"
-v2filenames=0
-v3filenames=0
+staTable=@Invalid()
+useOpenStreetMap=false